' vbs2js.VBS V1.00 (C) yoshioka.teruo@nifty.com 2004-11-18
' vbs2js.VBS converts VBScript to JScript.
' Usage: vbs2js vbsfile

Option Explicit
Dim fso
Dim fo
Dim iFile
Dim oFile
Dim oPath
Dim header
header="import System" & vbCRLF & _
"import System.Collections;" & vbCRLF & _
"var fso=new ActiveXObject('Scripting.FileSystemObject');" & vbCRLF & _
"var WScript=new Object();" & vbCRLF & _
"WScript.StdIn=fso.GetStandardStream(0);" & vbCRLF & _
"WScript.StdOut=fso.GetStandardStream(1);" & vbCRLF & _
"WScript.StdErr=fso.GetStandardStream(2);" & vbCRLF & _
"WScript.Echo=function(p){var pArray=new Array();" & vbCRLF & _
"for(var k=0;k<WScript.Echo.arguments.length;k++){pArray.push(WScript.Echo.arguments[k]);}" & vbCRLF & _
"WScript.StdOut.WriteLine(pArray.join(' '));}" & vbCRLF & _
"WScript.Arguments=function(n){return(Environment.GetCommandLineArgs()[n+1]);}" & vbCRLF & _
"var arguments:String[]=Environment.GetCommandLineArgs();" & vbCRLF & _
"var args:ArrayList=new ArrayList();" & vbCRLF & _
"for(var k=1;k<arguments.length;k++){args.Add(arguments[k]);}" & vbCRLF & _
"WScript.Arguments=args;" & vbCRLF & _
"WScript.Quit=function(n){Environment.Exit(n);}" & vbCRLF & _
"WScript.Sleep=function(msec:int){System.Threading.Thread.Sleep(msec);}" & vbCRLF & _
"var ext=fso.GetExtensionName(arguments[0]);" & vbCRLF & _
"if(ext=='') ext='EXE';" & vbCRLF & _
"WScript.ScriptName=fso.GetBaseName(arguments[0])+'.'+ext;" & vbCRLF & _
"WScript.ScriptFullName=fso.BuildPath(fso.GetParentFolderName(fso.GetAbsolutePathName(arguments[0])),WScript.ScriptName);" & vbCRLF & _
"WScript.FullName=WScript.ScriptFullName;" & vbCRLF & _
"WScript.Name=WScript.ScriptName;" & vbCRLF & _
"var SC=new ActiveXObject('ScriptControl');" & vbCRLF & _
"SC.Language='VBScript';" & vbCRLF & _
"SC.AllowUI=true;" & vbCRLF & _
"SC.TimeOut=-1;" & vbCRLF & _
"SC.AddObject('WScript',WScript,true);" & vbCRLF & _
"try{" & vbCRLF & _
"SC.ExecuteStatement("
Dim trailer
trailer="'');" & vbCRLF & _
"}catch(e){" & vbCRLF & _
"WScript.StdOut.WriteLine('Number:' + SC.Error.Number);" & vbCRLF & _
"WScript.StdOut.WriteLine('Description:' + SC.Error.Description);" & vbCRLF & _
"WScript.StdOut.WriteLine('Source:' + SC.Error.Source);" & vbCRLF & _
"WScript.StdOut.WriteLine('Text:' + SC.Error.Text);" & vbCRLF & _
"WScript.StdOut.WriteLine('Line:' + SC.Error.Line);" & vbCRLF & _
"WScript.StdOut.WriteLine('Column:' + SC.Error.Column);" & vbCRLF & _
"}"
Dim line
Dim re
Set re=new RegExp
re.IgnoreCase=True
re.Global=True

Set fso=CreateObject("Scripting.FileSystemObject")

If Wscript.Arguments.Count<>1 Then
    WScript.Echo "Usage: vbs2js vbsfile"
    WScript.Quit
End If
Set fo=fso.GetFile(WScript.Arguments(0))
oPath=fso.BuildPath(fso.GetParentFolderName(fo.Path),fso.GetBaseName(fo.Name) & ".JS")
Set iFile=fso.OpenTextFile(fo.Path)
Set oFile=fso.CreateTextFile(oPath)
oFile.Write header
Do While Not iFile.AtEndOfStream
  line=iFile.ReadLine
  re.Pattern="$bWScript\.":line=re.Replace(line,"WScript.")
  re.Pattern="\.StdIn$b":line=re.Replace(line,".StdIn")
  re.Pattern="\.StdOut$b":line=re.Replace(line,".StdOut")
  re.Pattern="\.StdErr$b":line=re.Replace(line,".StdErr")
  re.Pattern="\.Echo$b":line=re.Replace(line,".Echo")
  re.Pattern="\.Sleep$b":line=re.Replace(line,".Sleep")
  re.Pattern="\.Arguments$b":line=re.Replace(line,".Arguments")
  re.Pattern="\.Count$b":line=re.Replace(line,".Count")
  re.Pattern="\.Item$b":line=re.Replace(line,".Item")
  re.Pattern="\.Quit$b":line=re.Replace(line,".Quit")
  re.Pattern="\.ScriptFullName$b":line=re.Replace(line,".ScriptFullName")
  re.Pattern="\.ScriptName$b":line=re.Replace(line,".ScriptName")
  re.Pattern="\.FullName$b":line=re.Replace(line,".FullName")
  re.Pattern="\.Name$b":line=re.Replace(line,".Name")
  line=Replace(line,"\","\\")
  line=Replace(line,"'","\'")
  oFile.WriteLine "'" & line & "'+'\r\n' +"
Loop
oFile.Write trailer
iFile.Close
oFile.Close
WScript.Quit
