' vbs2jse.VBS V1.01 (C) yoshioka.teruo@nifty.com 2005-04-15
' vbs2jse.VBS converts VBScript to JScript.NET with VBScript.Encode.
' Usage: vbs2jse vbsfile

Option Explicit
Dim header
header="import System" & vbCRLF & _
"import System.Collections;" & vbCRLF & _
"var fso=new ActiveXObject('Scripting.FileSystemObject');" & vbCRLF & _
"var WScript=new Object();" & vbCRLF & _
"WScript.StdIn=fso.GetStandardStream(0);" & vbCRLF & _
"WScript.StdOut=fso.GetStandardStream(1);" & vbCRLF & _
"WScript.StdErr=fso.GetStandardStream(2);" & vbCRLF & _
"WScript.Echo=function(p){var pArray=new Array();" & vbCRLF & _
"for(var k=0;k<WScript.Echo.arguments.length;k++){pArray.push(WScript.Echo.arguments[k]);}" & vbCRLF & _
"WScript.StdOut.WriteLine(pArray.join(' '));}" & vbCRLF & _
"WScript.Arguments=function(n){return(Environment.GetCommandLineArgs()[n+1]);}" & vbCRLF & _
"var arguments:String[]=Environment.GetCommandLineArgs();" & vbCRLF & _
"var args:ArrayList=new ArrayList();" & vbCRLF & _
"for(var k=1;k<arguments.length;k++){args.Add(arguments[k]);}" & vbCRLF & _
"WScript.Arguments=args;" & vbCRLF & _
"WScript.Quit=function(n){Environment.Exit(n);}" & vbCRLF & _
"WScript.Sleep=function(msec:int){System.Threading.Thread.Sleep(msec);}" & vbCRLF & _
"var ext=fso.GetExtensionName(arguments[0]);" & vbCRLF & _
"if(ext=='') ext='EXE';" & vbCRLF & _
"WScript.ScriptName=fso.GetBaseName(arguments[0])+'.'+ext;" & vbCRLF & _
"WScript.ScriptFullName=fso.BuildPath(fso.GetParentFolderName(fso.GetAbsolutePathName(arguments[0])),WScript.ScriptName);" & vbCRLF & _
"WScript.FullName=WScript.ScriptFullName;" & vbCRLF & _
"WScript.Name=WScript.ScriptName;" & vbCRLF & _
"var SC=new ActiveXObject('ScriptControl');" & vbCRLF & _
"SC.Language='VBScript.Encode';" & vbCRLF & _
"SC.AllowUI=true;" & vbCRLF & _
"SC.TimeOut=-1;" & vbCRLF & _
"SC.AddObject('WScript',WScript,true);" & vbCRLF & _
"try{" & vbCRLF & _
"SC.ExecuteStatement("

Dim trailer
trailer=");" & vbCRLF & _
"}catch(e){" & vbCRLF & _
"WScript.StdOut.WriteLine('Number:' + SC.Error.Number);" & vbCRLF & _
"WScript.StdOut.WriteLine('Description:' + SC.Error.Description);" & vbCRLF & _
"WScript.StdOut.WriteLine('Source:' + SC.Error.Source);" & vbCRLF & _
"WScript.StdOut.WriteLine('Text:' + SC.Error.Text);" & vbCRLF & _
"WScript.StdOut.WriteLine('Line:' + SC.Error.Line);" & vbCRLF & _
"WScript.StdOut.WriteLine('Column:' + SC.Error.Column);" & vbCRLF & _
"}"

Dim fso
Set fso=CreateObject("Scripting.FileSystemObject")
Dim sce
Set sce=CreateObject("Scripting.Encoder")
Dim re
Set re=new RegExp
re.IgnoreCase=True
re.Global=True

Dim fo
Dim oPath
Dim iFile
Dim oFile
Dim Code
Dim k
Dim Char

If Wscript.Arguments.Count<>1 Then
  WScript.Echo "Usage: vbs2js vbsfile"
  WScript.Quit
End If
Set fo=fso.GetFile(WScript.Arguments(0))
oPath=fso.BuildPath(fso.GetParentFolderName(fo.Path),fso.GetBaseName(fo.Name) & ".JS")
Set iFile=fso.OpenTextFile(fo.Path)
Set oFile=fso.CreateTextFile(oPath)
oFile.Write header
Code=iFile.ReadAll
re.Pattern="$bWScript\.":Code=re.Replace(Code,"WScript.")
re.Pattern="\.StdIn$b":Code=re.Replace(Code,".StdIn")
re.Pattern="\.StdOut$b":Code=re.Replace(Code,".StdOut")
re.Pattern="\.StdErr$b":Code=re.Replace(Code,".StdErr")
re.Pattern="\.Echo$b":Code=re.Replace(Code,".Echo")
re.Pattern="\.Sleep$b":Code=re.Replace(Code,".Sleep")
re.Pattern="\.Arguments$b":Code=re.Replace(Code,".Arguments")
re.Pattern="\.Count$b":Code=re.Replace(Code,".Count")
re.Pattern="\.Item$b":Code=re.Replace(Code,".Item")
re.Pattern="\.Quit$b":Code=re.Replace(Code,".Quit")
re.Pattern="\.ScriptFullName$b":Code=re.Replace(Code,".ScriptFullName")
re.Pattern="\.ScriptName$b":Code=re.Replace(Code,".ScriptName")
re.Pattern="\.FullName$b":Code=re.Replace(Code,".FullName")
re.Pattern="\.Name$b":Code=re.Replace(Code,".Name")
Code=sce.EncodeScriptFile(".VBS", Code, 0, "VBScript")
oFile.Write "'"
For k=1 To Len(Code)
  Char=Mid(Code,k,1)
  If Asc(Char)<32 Or Char="'" Or Char="\" Or Asc(Char)=127 Then
    oFile.Write "\"&Right(Oct(512+Asc(Char)),3)
  Else
    oFile.Write Char
  End If
Next
oFile.Write "'"
oFile.Write trailer
iFile.Close
oFile.Close
WScript.Quit
